#pragma once

#include "stdafx.h"

#include "Graph.h"
namespace gc{

	CGraph::CGraph()
	{
		ntraces = 0;
		nwaves = 0;
		npts = 0;
		xLabel = "";
		yLabel = "";

		W = nullptr;
		XAxisNo=0;
	}

	CGraph::~CGraph()
	{
		int i;


		for(i=0;i<nwaves;i++){
			if(W[i]->A!=nullptr) delete [] W[i]->A;
			if(W[i]!=nullptr)delete W[i];
		}
		delete [] W;
	}


	int CGraph::MakeWaves(void)
	{
		int i;

		if(ntraces <= 0) return -1;
		if(npts <= 0) return -1;

		W = gcnew array<Wave^>(nwaves);
		for(i=0;i<nwaves;i++){
			W[i] = gcnew Wave;
			W[i]->A = gcnew array<double>(npts);
			W[i]->visible = true;
		}

		XPStart = 0;
		XPEnd = npts-1;
		Points = npts;

		return 0;
	}


	void CGraph::FindMinMax()
	{
		int i,j;
		array<double>^ t;
//		int imax, imin;
		double ymin,ymax;


		for(i=0;i<nwaves;i++){
			ymin=ymax=W[i]->A[0];
//			imax = imin = 0;
			t = W[i]->A;
			for(j=1;j<npts;j++){
				if(t[j] > ymax){
					ymax= t[j];
//					imax = j;
				}else if ( t[j] < ymin){
					ymin = t[j];
//					imin = j;
				}
			}

			W[i]->aMax=ymax;
			W[i]->aMin=ymin;
/*
			if(imin<=imax){
     			W[i]->iStart = imin;
			    W[i]->iEnd   = imax;
			}else{
     			W[i]->iStart = imax;
			    W[i]->iEnd   = imin;
			}
*/
			if(i==1){
				TheYMax = ymax;
				TheYMin = ymin;
			}else{
				if(TheYMax<ymax) TheYMax = ymax;
				if(TheYMin>ymin) TheYMin = ymin;
			}
		}
		YMax = TheYMax;
		YMin = TheYMin;
		return;
	}


	void CGraph::findXRange(double lower, double upper)
	{
		array<double>^  pA = W[XAxisNo]->A;

		int ixmin, ixmax;
		bool bFound = false;

		for(int i = XPStart ; i<=XPEnd ; i++){
			double f = pA[i];
			if((f>=lower) && (f<=upper)){
				if(!bFound){
					ixmax = ixmin = i;
					bFound = true;
				}else{
					ixmax = i;
				}
			}
		}

		if(!bFound) return;

		if(ixmin==ixmax){
			if(ixmin>0)ixmin--;
			if(ixmax<npts-1)ixmax++;
		}
		XPStart = ixmin;
		XPEnd = ixmax;
		Points = XPEnd - XPStart + 1;

	}




	void CGraph::FullGraph()
	{
		XPStart = 0;
		XPEnd = npts-1;

		XMin = W[XAxisNo]->aMin;
		XMax = W[XAxisNo]->aMax;

		findXRange(XMin, XMax);


		XOrigin = XMin;
		XDelta  = (Points>0) ? (XMax - XMin)/Points : 0;

		YMax = TheYMax;
		YMin = TheYMin;
	}
}